#include "irc_coroutine.hpp"

auto irc_coroutine::is_running() -> bool
{
    return promise().connection_ != nullptr;
}
auto irc_coroutine::exception() -> std::exception_ptr
{
    return promise().exception_;
}

auto irc_coroutine::start(Connection &connection) -> void
{
    promise().connection_ = connection.shared_from_this();
    resume();
}

void wait_ircmsg::stop() { ircmsg_slot_.disconnect(); }

void wait_timeout::stop() { timer_.reset(); }
